<template>
  <el-drawer
    v-model="showSidebar"
    :show-close="false"
    size="240px"
    :before-close="toggleSidebar"
    class="sidebar-languages"
  >
    <template #header="{ close }">
      <span class="--text3 text-sm">{{ $t("Select language") }}</span>
      <font-awesome-icon
        class="icon-angle-right close-icon --text3"
        icon="angle-right"
        @click="close"
      />
    </template>
    <el-divider style="margin: 0"/>
    <el-menu
      :default-active="defaultLanguageForDisplay"
      class="border-0 language"
      text-color="--text3"
      background-color="var(--background1)"
    >
      <el-menu-item v-for="lang, index in languageSetting" :key="lang" :index="index">
        <div
          class="flex items-center w-full cursor-pointer padding-y px-4 py-3 justify-between"
          @click="switchLanguage(lang.ISO)"
        >
          <div class="flex h-fit items-center">
            <div class="icon-lang mr-2">
              <img :src="getAssetImage(`assets/materials/languageIcon/square/${lang.ISO}.png`)" />
            </div>
            <div class="profile-menu-title text-sm" :class="lang.LanguageLocalName === defaultLanguageForDisplay ? 'active-language' : ''">
              {{ lang.LanguageLocalName }}
            </div>
          </div>
          <font-awesome-icon
            class="icon-check"
            icon="check"
            v-if="lang.LanguageLocalName === defaultLanguageForDisplay"
          />
        </div>
      </el-menu-item>
    </el-menu>
  </el-drawer>
</template>

<script lang="ts" setup>
import { useLanguageComponent } from "@/composables/useTheme";
import { computed } from "vue";
import { store } from '~~/store';

const {
  switchLanguage,
  languageSetting,
  defaultLanguageForDisplay,
} = useLanguageComponent();
const { getAssetImage } = commonHelper;
const showSidebar = computed(() => store.state.showSidebar);
const toggleSidebar = () => {
  store.commit("updateSidebar", !store.state.showSidebar);
};
</script>

<style>
.sidebar-languages.el-drawer,
ul.el-menu.el-menu--vertical.language {
  background-color: var(--background5);
}
.language {
  --el-menu-item-height: 40px;
  border: 0;
}
.profile-menu-title, .language .el-menu-item:hover {
  background-color: transparent;
  color: var(--text3);
}
.sidebar-languages .el-drawer__header {
  margin-bottom: 0;
  padding: 16px;
}
.sidebar-languages .el-drawer__body {
    padding: 0;
}
.active-language {
  color: var(--primary);
}
</style>
<style lang="scss" scoped>
.icon-lang {
  img {
    object-fit: cover;
    border-radius: 2px;
  }
  height: 16px;
  width: 22px;
  border-radius: 2px;
  overflow: hidden;
}
.m-angle-right-container svg {
  font-size: 16px;
}
.el-menu-item {
  padding: 0;
}
.icon-tick {
  width: 16px;
  height: 16px;
  margin-left: auto;
  fill: var(--primary);
  margin-right: 4px;
}
.icon-check {
  color: var(--primary);
  fill: var(--primary);
}
.el-divider--horizontal {
  border-color: #36412E;
}
</style>
